code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0			; extra word for far jump segment

new21:	cmp	ah,4eh			; FindFirst function?
	jne	start

	push	ax			; save registers
	push	si
	mov	si,dx			; point source to filespec
	cld
srch:	lodsb
	cmp	al,0			; terminator?
	je	next
	cmp	al,'?'			; ? wildcard?
	je	pass
	cmp	al,'*'			; * wildcard?
	jne	srch
pass:	pop	si			; has wildcard, pass it on
	pop	ax
	jmp	short start

next:	push	bp			; save base pointer
	mov	bp,sp

	pushf				; call FindFirst
	push	cs
	call	start
	jc	fail

	mov	ah,4fh			; FindNext (closes search slot)
	int	21h

	xor	ax,ax			; no error
	and	word ptr [bp+10],not 1	; clear carry flag on stack
	jmp	short exit

fail:	or	word ptr [bp+10],1	; set carry flag on stack

exit:	pop	bp
	pop	si
	add	sp,2			; AX = error code, not stack value
	iret

init:	mov	ax,3521h		; create jump to previous handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate, leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
